CoffeeShop/ViewModels/CoffeeListViewModel.cs
using CoffeeShop.Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace CoffeeShop.ViewModels
{
    public class CoffeeListViewModel
    {
        public IEnumerable<Coffee> AllCoffee { get; set; }
        public string currCategory { get; set; }
    }
}

CoffeeShop/ViewModels/HomeViewModel.cs
using CoffeeShop.Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace CoffeeShop.ViewModels
{
    public class HomeViewModel
    {
        public IEnumerable<Coffee> FavCoffee { get; set; }
    }
}

CoffeeShop/ViewModels/ShopCartViewModel.cs
using CoffeeShop.Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace CoffeeShop.ViewModels
{
    public class ShopCartViewModel
    {
        public ShopCart shopCart { get; set; }
    }
}

CoffeeShop/Controllers/CoffeeController.cs
using CoffeeShop.Data.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using CoffeeShop.Data.Models;
using CoffeeShop.ViewModels;

namespace CoffeeShop.Controllers
{
    public class CoffeeController : Controller
    {
        private readonly IAllCoffee _allCoffee;
        private readonly ICoffeeCategory _allCategories;

        public CoffeeController(IAllCoffee iAllCars, ICoffeeCategory iCoffeeCat)
        {
            _allCoffee = iAllCars;
            _allCategories = iCoffeeCat;
        }

        //<summary>
        //Return view cars
        //</summary>
        [Route("Coffee/List")]
        [Route("Coffee/List/{category}")]
        public ViewResult List(string category)
        {
            var _category = category;
            IEnumerable<Coffee> coffee = null;
            string currCategory = "";

            if (string.IsNullOrEmpty(category))
            {
                coffee = _allCoffee.Coffee.OrderBy(i => i.id);
            }
            else
            {
                if (string.Equals("Filtr-coffee", category, StringComparison.OrdinalIgnoreCase))
                {
                    coffee = _allCoffee.Coffee.Where(i => i.Category.categoryName.Equals("Фильтр-кофе")).OrderBy(i => i.id);
                    currCategory = "Фильтр-кофе";
                }
                else if (string.Equals("Espresso", category, StringComparison.OrdinalIgnoreCase))
                {
                    coffee = _allCoffee.Coffee.Where(i => i.Category.categoryName.Equals("Эспрессо")).OrderBy(i => i.id);
                    currCategory = "Эспрессо";
                }
                else if(string.Equals("Drip-package", category, StringComparison.OrdinalIgnoreCase))
                {
                    coffee = _allCoffee.Coffee.Where(i => i.Category.categoryName.Equals("Дрип-пакеты")).OrderBy(i => i.id);
                    currCategory = "Дрип-пакеты";
                }
            }

            var coffObj = new CoffeeListViewModel
            {
                AllCoffee = coffee,
                currCategory = currCategory
            };

            return View(coffObj);
        }

    }
}
 

CoffeeShop/Controllers/HomeController.cs
using CoffeeShop.Data.Interfaces;
using Microsoft.AspNetCore.Mvc;
using CoffeeShop.ViewModels;

namespace CoffeeShop.Controllers
{
    public class HomeController : Controller
    {
        
        private IAllCoffee _coffeeRep;

        public HomeController(IAllCoffee coffeeRep)
        {
            _coffeeRep = coffeeRep;
        }

        public ViewResult Index()
        {
            var homeCoffee = new HomeViewModel
            {
                FavCoffee = _coffeeRep.getCoffee
            };

            return View(homeCoffee);
        }
        
    }
}

CoffeeShop/Controllers/OrderController.cs
using CoffeeShop.Data.Interfaces;
using CoffeeShop.Data.Models;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace CoffeeShop.Controllers
{
    public class OrderController : Controller
    {
        private readonly IAllOrders allOrders;
        private readonly ShopCart shopCart;

        public OrderController(IAllOrders allOrders, ShopCart shopCart)
        {
            this.allOrders = allOrders;
            this.shopCart = shopCart;
        }

        public IActionResult Checkout()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Checkout(Order order)
        {
            shopCart.listShopItems = shopCart.getShopItems();

            if (shopCart.listShopItems.Count == 0)
            {
                ModelState.AddModelError("", "У вас должны быть товары");
            }

            if (ModelState.IsValid)
            {
                allOrders.createOrder(order);
                return RedirectToAction("Complete");
            }

            return View(order);
        }

        public IActionResult Complete()
        {
            ViewBag.Message = "Заказ успешно обработан";
            return Complete();
        }
    }
}

CoffeeShop/Controllers/ShopCartController.cs
using CoffeeShop.Data.Interfaces;
using CoffeeShop.Data.Models;
using CoffeeShop.ViewModels;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace CoffeeShop.Controllers
{
    public class ShopCartController : Controller
    {
        private IAllCoffee _carRep;
        private readonly ShopCart _shopCart;

        public ShopCartController(IAllCoffee carRep, ShopCart shopCart)
        {
            _carRep = carRep;
            _shopCart = shopCart;
        }

        public ViewResult Index()
        {
            var items = _shopCart.getShopItems();
            _shopCart.listShopItems = items;

            var obj = new ShopCartViewModel
            {
                shopCart = _shopCart
            };

            return View(obj);
        }

        public RedirectToActionResult addToCart(int id)
        {
            var item = _carRep.Coffee.FirstOrDefault(i => i.id == id);
            if (item != null)
            {
                _shopCart.AddToCart(item);
            }

            return RedirectToAction("Index");
        }


        public IActionResult Message_Item_Add()
        {
            ViewBag.Message = "Товар добавлен в корзину";
            return View();
        }
    }
}

CoffeeShop/Views/Coffee/List.cshtml
@model CoffeeListViewModel

<h1>@Model.currCategory</h1>
<div class="row mt-3 mb-2">
    @{
        foreach (Coffee coffee in Model.AllCoffee)
        {
            @Html.Partial("AllCoffee", coffee)
        }
    }
</div>

CoffeeShop/Views/Home/Index.cshtml
@model HomeViewModel

<h1>Весь ассортимент</h1>
<div class="row mt-3 mb-2">
    @{
        foreach (Coffee coffee in Model.FavCoffee)
        {
            @Html.Partial("AllCoffee", coffee)
        }
    }
</div>

CoffeeShop/Views/Order/Checkout.cshtml
@model Order

 <h3>Оформление заказа </h3>
<div class="row mb-5">
    <form asp-action="Checkout" method="post" class="form-horizontal">
        <div class="form-group">
            <label asp-for="name"></label>
            <div class="col-12">
                <input asp-for="name" class="form-control" />
                <span asp-validation-for="name" class="text-danger"></span>
            </div>
        </div>
        <div class="form-group">
            <label asp-for="surname"></label>
            <div class="col-12">
                <input asp-for="surname" class="form-control" />
                <span asp-validation-for="surname" class="text-danger"></span>
            </div>
        </div>
        <div class="form-group">
            <label asp-for="adress"></label>
            <div class="col-12">
                <input asp-for="adress" class="form-control" />
                <span asp-validation-for="adress" class="text-danger"></span>
            </div>
        </div>
        <div class="form-group">
            <label asp-for="phone"></label>
            <div class="col-12">
                <input asp-for="phone" class="form-control" />
                <span asp-validation-for="phone" class="text-danger"></span>
            </div>
        </div>
        <div class="form-group">
            <label asp-for="email"></label>
            <div class="col-12">
                <input asp-for="email" class="form-control" />
                <span asp-validation-for="email" class="text-danger"></span>
            </div>
        </div>
        <input class="btn btn-success" type="submit" value="Завершить заказ"/>
    </form>
</div> 

CoffeeShop/Views/Order/Complete.cshtml
<h3>@ViewBag.Message</h3>

CoffeeShop/Views/Shared/AllCoffee.cshtml
@model CoffeeShop.Data.Models.Coffee

<div class="col-lg-3">
    <img class="img-thumbnail" src="@Model.img" alt="@Model.name">
    <h2>@Model.name</h2>
    <p>@Model.shortDesc</p>
    <p>Цена: @Model.price.ToString("c")</p>
    <p>
        <a class="btn btn-warning"
           asp-controller="ShopCart"
           asp-action="addToCart"
           asp-route-id="@Model.id">Добавить в корзину</a>
    </p>
</div> 

CoffeeShop/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - CoffeeShop</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-controller="Home" asp-action="Index">CoffeeShop</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#main_nav">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="main_nav">
                    <ul class="navbar-nav ms-auto">
                        <li class="nav-item">
                            <a class="nav-link text-dark" href="/Coffee/List/Filtr-coffee">Фильтр-кофе</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" href="/Coffee/List/Espresso">Эспрессо</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" href="/Coffee/List/Drip-package">Дрип-пакеты</a>
                        </li>
                    </ul>
                    <ul class="navbar-nav ml-auto">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-controller="ShopCart" asp-action="Index">Корзина</a>
                        </li>  
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2021 - CoffeeShop - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>

CoffeeShop/Views/ShopCart/Index.cshtml
@model ShopCartViewModel

<div class="container mt-4">
    @foreach (var el in Model.shopCart.listShopItems)
    {
        <div class="alert alert-warning mt-3">
            <b>Кофе:</b> @el.coffee.name<br />
            <b>Цена:</b> @el.coffee.price.ToString("c")
        </div>
    }
    <hr />
    <a  class="btn btn-danger mb-4" asp-controller="Order" asp-action="Checkout">Оплатить</a>
</div> 

CoffeeShop/Views/ShopCart/Message_Item_Add.cshtml
<h3>@ViewBag.Message</h3>